# Operators

Operators are used to perform a specific operation in `cohls` or `cohl` command. following are few operators.

1. [cohls operators](#cohls-operators)
2. [cohl operators](#cohl-operators)

## Cohls Operators

1. [create operator](#create)
2. [erase operator](#erase)
3. [config operator](#config)
4. [add operator](#add)
5. [pop operator](#pop)
6. [retitle operator](#retitle)

### Create

Create operator is used to create a session inside given directory. session object is generated by the create operator.
This session object holds information about codes and how to execute the codes. the filename pattern can be extablished within the session object.
to run this command we require a arguement which is title. This title is for session object which may be used while printing and exporting the files.

```ps
cohls create "practical 11 programs"
```

### Erase

Erase operator is used to delete the session object created for this current working directory.
By deleting the session object a new session can be created.

This command expects no arguements.

```ps
cohls erase
```

### Config

Config operator is used to make changes in session object where the pattern to execute files is stored.
Config command is automatically executed once the create is executed.

[Read More about configurations](./config.md)

```ps
cohls config
```

### Add

Add operator lets you add a code into the directory session object codes.
These are the codes which are exported while printing or exporting.

This expects arguements used in the commands to execute while configs.

If not all required args are passed it may cause unexpected behaviour or error while gatering output of file.

```ps
cohls add ...args
```

> arg[i] will be replaced with $i+1 in commands and filename

### Pop

Pop operator is used to remove last added code into session codes.

```ps
cohls pop
```

### Retitle

Retitle operator lets you overwrite the title on codes.
You can use a number as arg to specify the code which you want to retitle.
By Default Retitle runs for all of the codes.

```ps
cohls retitle num
```

or

```ps
cohls retitle
```

### Addpb

Addpb is used to create a page break in between last added code and next code which will be added.

```ps
cohls addpb
```

## Cohl Operators

1. [shelp operator](#shelp)
2. [savepage operator](#savepage)
3. [theme & font change](#theme--font)
4. [print operator](#print)

### shelp

This operator is used to get help about the operators which redirects to [commands.md](./commands.md)

### savepage

This operators saves all added codes as html page to current working directory with the filename as `CHNP~$title.html` to cwd.

```ps
cohl savepage
```

### theme & font

Theme and font lets you set theme of code blocks and font of codes respectively.

#### Theme

```ps
cohl theme
```

#### Font

```ps
cohl font
```

### print

This command creates localhost web server which serves the page which can be printed to obtain pdf or prints

```ps
cohl print
```
